android studio 3.5 Warning: The rule `-keep public class * extends androidx.versionedparcelable.VersionedParcelable { <init>(); }` uses extends-ThrowExceptions

Exception or error:

Today, I updated my Android Studio to 3.5. After updated, I found below warning when I try to run the app.

The rule -keep public class * extends
androidx.versionedparcelable.VersionedParcelable { (); } uses
extends but actually matches implements.

I know warning is related with my proguard rules. So, I double checked my proguard rule file, but I am sure I didn’t add that rule and it is not in my proguard rule file.

My Progurad File

Below is the warning when I build the project.

enter image description here

My project is using AndroidX. Can anyone know that warning can be skipped or where that warning came from? Any ideas or alternative ways will be appreciating..

How to solve:

It’s a bug in the proguard.txt file in the versionedparcelable.aar version 1.0.0. This was fixed in version 1.1.0, however, if you’re not using libraries that depends on the new version you’ll get this warning in Android Studio 3.5.

In version 1.0.0 the proguard.txt file includes the following line:

-keep public class * extends androidx.versionedparcelable.VersionedParcelable

This was fixed in version 1.1.0:

-keep public class * implements androidx.versionedparcelable.VersionedParcelable

To bypass this issue you can force using the latest version by adding the following line to your build.gradle:

implementation "androidx.versionedparcelable:versionedparcelable:1.1.0"

###

Why not do this for that project:

  1. Disable minify in “build.gradle (Module: app)” file:
minifyEnabled false
  1. and you use proguard for optimization, such as:
proguardFiles getDefaultProguardFile ('proguard-android-optimize.txt')

Leave a Reply

Your email address will not be published. Required fields are marked *